{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $01000000}
{$IMAGEBASE $00400000}

{$apptype console}

type
  PEdge = ^TEdge;
  TEdge = record
    Dest: integer;
    Next: PEdge;
  end;


var
  n, m: integer;
  edges: array of PEdge;
  colors: array of byte;

function dfs(StartingWith: integer; StartingColor: byte): boolean;
var
  e: PEdge;
begin
  Result := false;
  colors[StartingWith] := StartingColor;
  e := edges[StartingWith];
  while e <> nil do begin
    if colors[e^.Dest] = StartingColor then
      Exit
    else if colors[e^.Dest] = 0 then
      if not dfs(e^.Dest, 3 - StartingColor) then
        Exit;
    e := e^.Next;
  end;
  Result := true;
end;


var
  fi, fo: textfile;
  i, a, b: integer;
  e: PEdge;
  ok: boolean;
begin
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  Reset(fi);
  Rewrite(fo);

  Read(fi, n, m);
  SetLength(edges, n);
  FillChar(edges[0], n * SizeOf(edges[0]), 0);
  for i := 0 to m - 1 do begin
    Read(fi, a, b);
    Dec(a);
    Dec(b);

    New(e);
    e^.Dest := b;
    e^.Next := edges[a];
    edges[a] := e;

    New(e);
    e^.Dest := a;
    e^.Next := edges[b];
    edges[b] := e;
  end;

  SetLength(colors, n);
  FillChar(colors[0], n, 0);
  ok := true;
  for i := 0 to n - 1 do begin
    if (colors[i] = 0) then begin
      if not dfs(i, 1) then begin
        ok := false;
        Break;
      end;
    end;
  end;

  ok := ok and (n > 1);
  
  if ok then
    Write(fo, 'BIPARTITE')
  else
    Write(fo, 'NO');
  
  CloseFile(fo);
  CloseFile(fi);
end.
